// Marmalade headers
#include "s3e.h"

// iwGame engine headers

// Game headers
#include "Common.h"
#include "Game.h"
#include "IwGameHttp.h"
#include "IwGameFile.h"
int32 FileRetrievedAsyncCallback(void* caller, void* data)
{
	CIwGameFile* file = (CIwGameFile*)caller;


	delete file;

	return 0;
}

int main()
{
	// Init Game
	Game::Create();
	GAME->Init();

	// Start the compass
	IW_GAME_INPUT->startCompass();

	CIwGameFile* aync_image_file = new CIwGameFile();
	aync_image_file->setFileAvailableCallback(FileRetrievedAsyncCallback, NULL);
	aync_image_file->Open("http://www.battleballz.com/bb_icon.gif", NULL, false);

	// Download an image file from the web
	CIwGameFile* image_file = new CIwGameFile();
	image_file->Open("http://www.battleballz.com/bb_icon.gif", NULL, true);
	image_file->Close();

	// Create an image from the downloaded gif file
	CIwGameImage* image = new CIwGameImage();
	if (image_file->isFileAvailable() && image_file->getError() == CIwGameFile::ErrorNone)
		image->Init("", image_file->getContent(), image_file->getContentLength(), false);
	delete image_file;

	// Create a test sprite to display our downloaded gif
	CIwGameBitmapSprite* test_sprite = new CIwGameBitmapSprite();
	test_sprite->setImage(image);
	test_sprite->setDestSize(image->getWidth(), image->getHeight());
	test_sprite->setSrcRect(0, 0, image->getWidth(), image->getHeight());
	test_sprite->setPosition(20 + image->getWidth() / 2, 20 + image->getHeight() / 2);
	test_sprite->setScale(2 * IW_GEOM_ONE);

	// Main Game Loop
	while (!s3eDeviceCheckQuitRequest())
	{
		// Update the game
		if (!GAME->Update())
			break;

		// Check for back button quit
		if (IW_GAME_INPUT->isKeyDown(s3eKeyAbsBSK))
			break;

		// Draw the scene
		GAME->Draw();

		// Update test sprite angle
		test_sprite->setAngle((float)-IW_GAME_INPUT->getCompassDirection());

		// Draw test sprite to show remote image downloading working
		test_sprite->Draw();

		// Update http manager
		IW_GAME_HTTP_MANAGER->Update();
	}

	// Clean up image
	if (image != NULL)
		delete image;
	if (test_sprite != NULL)
		delete test_sprite;

	GAME->Release();
	Game::Destroy();

    return 0;
}

